#ifndef HPZREF_TXNFORMATTER_H
#define HPZREF_TXNFORMATTER_H

#include <sstream>
#include <fstream>

/* #include "C:\Users\DVitale\Downloads\Client\TPC-E\incTPC-E/inc/EGenStandardTypes.h"
#include "C:\Users\DVitale\Downloads\Client\TPC-E\incTPC-E/inc/DriverParamSettings.h"
#include "C:\Users\DVitale\Downloads\Client\TPC-E\incTPC-E/inc/EGenVersion.h"
#include "C:\Users\DVitale\Downloads\Client\TPC-E\incTPC-E/inc/BaseLogger.h"
#include "C:\Users\DVitale\Downloads\Client\TPC-E\incTPC-E/inc/locking.h"
#include "C:\Users\DVitale\Downloads\Client\TPC-E\incTPC-E/inc/DateTime.h"
#include "C:\Users\DVitale\Downloads\Client\TPC-E\incTPC-E/inc/TxnHarnessStructs.h" */
#include "../../TPC-E/inc/EGenLogger.h"
#include "../../TPC-E/inc/TxnHarnessStructs.h"
#include "HPZREFXPTxnStructs.h"

using namespace TPCE;

namespace HPZREF
{

class HPZREFTxnFormatter 
{
private:

	char * FormatTS(char * buf, TIMESTAMP_STRUCT structTS, const INT32 dtFormat)
	{
		if (structTS.year == 0 && structTS.hour == 0)
		{
			strcpy(buf, "");
		}
		else
		{
			CDateTime * pDT1 = new CDateTime(&structTS);
			strcpy(buf, pDT1->ToStr(dtFormat));
		}

		return buf;
	}

public:
    HPZREFTxnFormatter()
    {
    };

	~HPZREFTxnFormatter()
	{
	}

	void FormatBrokerVolumeTxn(TBrokerVolumeTxnInput * pTxn, TXPBrokerVolumeTxnInput * pXPTxn)
	{
		memset(pXPTxn, 0x20, sizeof(&pXPTxn));

		strcpy(pXPTxn->sector_name, pTxn->sector_name);	
		for (int idx = 0; idx < F_max_broker_list_len; idx++)
		{
			strcpy(pXPTxn->broker_list[idx], pTxn->broker_list[idx]);
		}		
	}

	void FormatCustomerPositionTxn(TCustomerPositionTxnInput * pTxn, TXPCustomerPositionTxnInput * pXPTxn)
	{
		memset(pXPTxn, 0x20, sizeof(&pXPTxn));

		sprintf(pXPTxn->acct_id_idx, TIdent_charfmt, pTxn->acct_id_idx);
		sprintf(pXPTxn->cust_id, TIdent_charfmt, pTxn->cust_id);
		sprintf(pXPTxn->get_history, bool_charfmt, pTxn->get_history);
		strcpy(pXPTxn->tax_id, pTxn->tax_id);				
	}

	void FormatMarketWatchTxn(TMarketWatchTxnInput * pTxn, TXPMarketWatchTxnInput * pXPTxn)
	{
		memset(pXPTxn, 0x20, sizeof(&pXPTxn));

		sprintf(pXPTxn->acct_id, TIdent_charfmt, pTxn->acct_id);
		sprintf(pXPTxn->c_id, TIdent_charfmt, pTxn->c_id);
		sprintf(pXPTxn->ending_co_id, TIdent_charfmt, pTxn->ending_co_id);
		sprintf(pXPTxn->starting_co_id, TIdent_charfmt, pTxn->starting_co_id);
		FormatTS(pXPTxn->start_day, pTxn->start_day, dateonly_fmtcode);
		strcpy(pXPTxn->industry_name, pTxn->industry_name);
	}

	void FormatSecurityDetailTxn(TSecurityDetailTxnInput * pTxn, TXPSecurityDetailTxnInput * pXPTxn)
	{
		memset(pXPTxn, 0x20, sizeof(&pXPTxn));

		sprintf(pXPTxn->max_rows_to_return, INT32_charfmt, pTxn->max_rows_to_return);
		sprintf(pXPTxn->access_lob_flag, bool_charfmt, pTxn->access_lob_flag);
		FormatTS(pXPTxn->start_day, pTxn->start_day, dateonly_fmtcode);
		strcpy(pXPTxn->symbol, pTxn->symbol);
	}

	void FormatTradeLookupTxn(TTradeLookupTxnInput * pTxn, TXPTradeLookupTxnInput * pXPTxn)
	{
		memset(pXPTxn, 0x20, sizeof(&pXPTxn));

		for (int idx = 0; idx < TradeLookupFrame1MaxRows; idx++)
		{
			sprintf(pXPTxn->trade_id[idx], TTrade_charfmt, pTxn->trade_id[idx]);
		}
		sprintf(pXPTxn->acct_id, TIdent_charfmt, pTxn->acct_id);
		sprintf(pXPTxn->max_acct_id, TIdent_charfmt, pTxn->max_acct_id);
		sprintf(pXPTxn->frame_to_execute, INT32_charfmt, pTxn->frame_to_execute);
		sprintf(pXPTxn->max_trades, INT32_charfmt, pTxn->max_trades);
		FormatTS(pXPTxn->end_trade_dts, pTxn->end_trade_dts, datetime_fmtcode);
		FormatTS(pXPTxn->start_trade_dts, pTxn->start_trade_dts, datetime_fmtcode);
		strcpy(pXPTxn->symbol, pTxn->symbol);
	}

	void FormatTradeOrderTxn(TTradeOrderTxnInput * pTxn, TXPTradeOrderTxnInput * pXPTxn)
	{
		memset(pXPTxn, 0x20, sizeof(&pXPTxn));

		sprintf(pXPTxn->requested_price, double_charfmt, pTxn->requested_price);
		sprintf(pXPTxn->acct_id, TIdent_charfmt, pTxn->acct_id);
		sprintf(pXPTxn->is_lifo, INT32_charfmt, pTxn->is_lifo);
		sprintf(pXPTxn->roll_it_back, INT32_charfmt, pTxn->roll_it_back);
		sprintf(pXPTxn->trade_qty, INT32_charfmt, pTxn->trade_qty);
		sprintf(pXPTxn->type_is_margin, INT32_charfmt, pTxn->type_is_margin);
		strcpy(pXPTxn->co_name, pTxn->co_name);
		strcpy(pXPTxn->exec_f_name, pTxn->exec_f_name);
		strcpy(pXPTxn->exec_l_name, pTxn->exec_l_name);
		strcpy(pXPTxn->exec_tax_id, pTxn->exec_tax_id);
		strcpy(pXPTxn->issue, pTxn->issue);
		strcpy(pXPTxn->st_pending_id, pTxn->st_pending_id);
		strcpy(pXPTxn->st_submitted_id, pTxn->st_submitted_id);
		strcpy(pXPTxn->symbol, pTxn->symbol);
		strcpy(pXPTxn->trade_type_id, pTxn->trade_type_id);
	}

	void FormatTradeResultTxn(TTradeResultTxnInput * pTxn, TXPTradeResultTxnInput * pXPTxn)
	{
		memset(pXPTxn, 0x20, sizeof(&pXPTxn));

		sprintf(pXPTxn->trade_price, double_charfmt, pTxn->trade_price);
		sprintf(pXPTxn->trade_id, TTrade_charfmt, pTxn->trade_id);
	}

	void FormatMarketFeedTxn(TMarketFeedTxnInput * pTxn, TXPMarketFeedTxnInput * pXPTxn)
	{
		memset(pXPTxn, 0x20, sizeof(&pXPTxn));

		sprintf(pXPTxn->unique_symbols, INT32_charfmt, pTxn->unique_symbols);
		strcpy(pXPTxn->StatusAndTradeType.status_submitted, pTxn->StatusAndTradeType.status_submitted);
		strcpy(pXPTxn->StatusAndTradeType.type_limit_buy, pTxn->StatusAndTradeType.type_limit_buy);
		strcpy(pXPTxn->StatusAndTradeType.type_limit_sell, pTxn->StatusAndTradeType.type_limit_sell);
		strcpy(pXPTxn->StatusAndTradeType.type_stop_loss, pTxn->StatusAndTradeType.type_stop_loss);
				
		for (int idx = 0; idx < F_max_feed_len; idx++)
		{
			sprintf(pXPTxn->Entries[idx].price_quote, double_charfmt, pTxn->Entries[idx].price_quote);
			sprintf(pXPTxn->Entries[idx].trade_qty, INT32_charfmt, pTxn->Entries[idx].trade_qty);
			strcpy (pXPTxn->Entries[idx].symbol, pTxn->Entries[idx].symbol);
		}
	}

	void FormatTradeStatusTxn(TTradeStatusTxnInput * pTxn, TXPTradeStatusTxnInput * pXPTxn)
	{
		memset(pXPTxn, 0x20, sizeof(&pXPTxn));

		sprintf(pXPTxn->acct_id, TIdent_charfmt, pTxn->acct_id);
	}

	void FormatTradeUpdateTxn(TTradeUpdateTxnInput * pTxn, TXPTradeUpdateTxnInput * pXPTxn)
	{
		memset(pXPTxn, 0x20, sizeof(&pXPTxn));

		for (int idx = 0; idx < TradeUpdateFrame1MaxRows; idx++)
		{
			sprintf(pXPTxn->trade_id[idx], TTrade_charfmt, pTxn->trade_id[idx]);
		}

		sprintf(pXPTxn->acct_id, TIdent_charfmt, pTxn->acct_id);
		sprintf(pXPTxn->max_acct_id, TIdent_charfmt, pTxn->max_acct_id);
		sprintf(pXPTxn->frame_to_execute, INT32_charfmt, pTxn->frame_to_execute);
		sprintf(pXPTxn->max_trades, INT32_charfmt, pTxn->max_trades);
		sprintf(pXPTxn->max_updates, INT32_charfmt, pTxn->max_updates);
		FormatTS(pXPTxn->end_trade_dts, pTxn->end_trade_dts, datetime_fmtcode);
		FormatTS(pXPTxn->start_trade_dts, pTxn->start_trade_dts, datetime_fmtcode);
		strcpy(pXPTxn->symbol, pTxn->symbol);
	}
	
	void FormatDataMaintenanceTxn(TDataMaintenanceTxnInput * pTxn, TXPDataMaintenanceTxnInput * pXPTxn)
	{
		memset(pXPTxn, 0x20, sizeof(&pXPTxn));

		sprintf(pXPTxn->acct_id, TIdent_charfmt, pTxn->acct_id);
		sprintf(pXPTxn->c_id, TIdent_charfmt, pTxn->c_id);
		sprintf(pXPTxn->co_id, TIdent_charfmt, pTxn->co_id);
		sprintf(pXPTxn->day_of_month, INT32_charfmt, pTxn->day_of_month);
		strcpy(pXPTxn->symbol, pTxn->symbol);
		strcpy(pXPTxn->table_name, pTxn->table_name);
		strcpy(pXPTxn->tx_id, pTxn->tx_id);
	}
	
	void FormatTradeCleanupTxn(TTradeCleanupTxnInput * pTxn, TXPTradeCleanupTxnInput * pXPTxn)
	{
		memset(pXPTxn, 0x20, sizeof(&pXPTxn));

		sprintf(pXPTxn->start_trade_id, TTrade_charfmt, pTxn->start_trade_id);
		strcpy(pXPTxn->st_canceled_id, pTxn->st_canceled_id);
		strcpy(pXPTxn->st_pending_id, pTxn->st_pending_id);
		strcpy(pXPTxn->st_canceled_id, pTxn->st_canceled_id);
		strcpy(pXPTxn->st_submitted_id, pTxn->st_submitted_id);
	}

};

}   // namespace HPZREF

#endif //HPZREF_TXNFORMATTER_H
